=== Tests/Dependency/1/CMakeLists.txt ===
add_library( One OneSrc.c )
# This library has no dependencies
target_link_libraries( One "" )
