=== Tests/RunCMake/include_guard/global_script_dir/CMakeLists.txt ===
include(GlobScript)
